//#####################################################################
// Copyright 2009, Andrew Selle.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef COMPILE_WITHOUT_DYADIC_SUPPORT
#ifndef __ADVECTION_COLLIDABLE_POLICY__
#define __ADVECTION_COLLIDABLE_POLICY__

#include <PhysBAM_Geometry/Grids_Dyadic_Advection_Collidable/ADVECTION_COLLIDABLE_DYADIC_FORWARD.h>
#include <PhysBAM_Geometry/Grids_Dyadic_Interpolation_Collidable/INTERPOLATION_COLLIDABLE_POLICY_DYADIC.h>

namespace PhysBAM{

template<class T_GRID>
struct ADVECTION_COLLIDABLE_POLICY;

template<class T>
struct ADVECTION_COLLIDABLE_POLICY<OCTREE_GRID<T> >
{
private:
    typedef OCTREE_GRID<T> T_GRID;
public:
    // collidable
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_CELL_DYADIC<T_GRID,T> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_CELL;
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_FACE_DYADIC<T_GRID> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_FACE;
    // slip collidable
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_CELL_DYADIC<T_GRID,T> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_SLIP_CELL;
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_FACE_DYADIC<T_GRID> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_SLIP_FACE;
};

template<class T>
struct ADVECTION_COLLIDABLE_POLICY<QUADTREE_GRID<T> >
{
private:
    typedef QUADTREE_GRID<T> T_GRID;
public:
    // collidable
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_CELL_DYADIC<T_GRID,T> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_CELL;
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_FACE_DYADIC<T_GRID> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_FACE;
    // slip collidable
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_CELL_DYADIC<T_GRID,T> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_SLIP_CELL;
    typedef ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_FACE_DYADIC<T_GRID> ADVECTION_SEMI_LAGRANGIAN_COLLIDABLE_SLIP_FACE;
};

}
#endif
#endif
